SystemOrganization addCategory: 'OrbeonBPMWebBasic'!

SEWAFWebObjectComposite subclass: #WABasicBpmChartComposite
	instanceVariableNames: 'canvas report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 13:22'!
analyzeQueryBlockIfFail: aOneArgumentBlock	
	| codeAnalyzer |

	codeAnalyzer := BpmProcessConditionCodeAnalyzer for: ((self searchValueAt: 'process-condition') ifNil: [^self] ifNotNil: [:value | value]).

	codeAnalyzer analyze.
	codeAnalyzer hasWarinings ifTrue: [^aOneArgumentBlock value: codeAnalyzer].

	^codeAnalyzer! !

!WABasicBpmChartComposite methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2016 10:47'!
canvas
	^canvas! !

!WABasicBpmChartComposite methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2016 10:47'!
canvas: newValue
	canvas := newValue! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 07:34'!
getAllArray

	^Array with: ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 08:02'!
getApplicationName

	^self searchValueAt: 'application' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:37'!
getBpmUserName

	^self searchValueAt: 'bpm-user' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/12/2016 10:37'!
getDateFromSearchValueNamed: aString onError: anObject

	^[Date fromString: (self searchValueAt: aString)] 
		on: Error 
		do: [:err | (anObject class == Date) ifTrue: [self addSearchValue: anObject named: aString].
		anObject]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getEndDate

	^self getDateFromSearchValueNamed: 'end' onError: (Date fromString: '12/31/2016')! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFieldName

	^(self searchValueAt: 'field-name' ifAbsent: [^nil]), '[s]'  "FIX THIS - FIELD NAMES INCLUDES THE TYPE"! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFieldName2

	^(self searchValueAt: 'field-name-2' ifAbsent: [^nil])! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getFormName

	^self searchValueAt: 'form-name' ifAbsent: [^nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/17/2016 08:47'!
getFrontOfficeRoleClass

	^BpmFrontOfficeRole! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/17/2016 08:45'!
getProcessDefinitionClass

	^BpmProcessDefinition! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getProcessFieldList
	| fields selectedFormName |

	fields := OrderedCollection new.
	selectedFormName := self getFormName.

	self getSelectedProcessDefinitions do: [:procDef | 
		(procDef getTasks select: [:each | each name = selectedFormName]) do: [:eachTask | fields addAll: eachTask getComponentClass getFieldsNames]].

	^fields asSet asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/21/2016 04:20'!
getProcessFormsList
	| forms |

	forms := OrderedCollection new.

	self getSelectedProcessDefinitions do: [:procDef | forms addAll: procDef getOrderedTasksNames].

	^forms asSet asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 09:46'!
getProcessName

	^self searchValueAt: 'process-name' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 09:08'!
getRoleName

	^self searchValueAt: 'role' ifAbsent: [nil]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getSelectedProcessDefinitions
	| versions |

	versions := BpmProcessDefinition getAllProcessesNamed: self getProcessName in: self getApplicationName.

	self isAllVersionSelected ifTrue: [^versions].

	^versions select: [:each | each version printString = self getVersion]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getStartDate

	^self getDateFromSearchValueNamed: 'start' onError: (Date fromString: '01/01/2016')! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/10/2016 03:49'!
getVersion

	^(self searchValueAt: 'version' ifAbsent: [^nil]) ifNotNil: [:value | (value = 'All') ifTrue: [nil] ifFalse: [value]]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 09:42'!
initialize

	super initialize.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/19/2016 07:19'!
isAllRolesSelected

	^(self searchValueAt: 'role' ifAbsent: [^false]) = ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/19/2016 07:19'!
isAllVersionSelected

	^(self searchValueAt: 'version' ifAbsent: [^false]) = ('All' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isAverageTaskTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Average Time per Task' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isBarChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Bar Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isCreationDayDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Creation Day' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isDonutChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Donut Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isDoubleBarChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Double Bar Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/06/2016 07:56'!
isDoubleChart

	^self isDoubleBarChart or: [self isDoubleDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:26'!
isDoubleDonutChart

	^(self searchValueAt: 'chart-type' ifAbsent: [nil]) = ('Double Donut Chart' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:27'!
isFieldValueDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Field Value' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:27'!
isNumberOfTasksDistributionSelection

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 06:39'!
isNumberOfUsersDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Users' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessDefinitionDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Process Definition' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessDefinitionDistributionAndBarChart

	^self isProcessDefinitionDistribution and:[self isBarChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessDefinitionDistributionAndDonutChart

	^self isProcessDefinitionDistribution and:[self isDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessesAverageTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Processes Average Time' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:29'!
isProcessInstanceDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Process Instances' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isProcessInstanceDistributionAndBarChart

	^self isProcessInstanceDistribution and:[self isBarChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isProcessInstanceDistributionAndDonutChart

	^self isProcessInstanceDistribution and:[self isDonutChart]! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isTasksAverageTimeDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Tasks Average Time' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isUnassignedTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Unassigned Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isUserNumberOfTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Number of Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/12/2016 08:30'!
isUserPossibleTasksDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Possible Tasks' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'query variables' stamp: 'BrunoBB 11/13/2016 13:38'!
queryBlock

	^(self searchValueAt: 'process-condition') 
		ifNil: [[:each | true]] 
		ifNotNil: [:blockString | [blockString evaluate isBlock 
											ifTrue: [blockString evaluate] 
											ifFalse: [[:each | false]] ] on: Error do: [:ex | [:each | false]]]! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 12:58'!
queryBlockFailedWith: aBpmCodeAnalyzer

	self addSearchValue: ' " ', aBpmCodeAnalyzer printCodeWarnings, ' " ', String lf, (self searchValueAt: 'process-condition')
			named: 'process-condition'! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderActiveDistributionComboOn: html withDistribution: distributionNames

	^self renderGenericActiveComboOn: html withList: distributionNames forVariable: 'distribution' label: ('Distribution' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 09:36'!
renderApplicationComboOn: html

	self renderApplicationComboOn: html withApplications: (self session user getBackofficeApplications collect: [:each | each applicationName]) asSortedCollection.! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderApplicationComboOn: html withApplications: applicationNames

	^self renderGenericActiveComboOn: html withList: (#(''), applicationNames) forVariable: 'application' label: ('Application' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderChartTypeComboOn: html withCharts: chartsNames
	| chartTypes |

	chartTypes := chartsNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericComboOn: html withList: chartTypes forVariable: 'chart-type' label: ('Chart Type' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/01/2016 09:19'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAreaOn: html].

	canvas notNil ifTrue: [self renderGraphOn: html]! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:10'!
renderDistributionComboOn: html withDistribution: distributionNames
	| distributionTypes |

	distributionTypes := distributionNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericComboOn: html withList: distributionTypes forVariable: 'distribution' label: ('Distribution' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 01/09/2017 06:13'!
renderGraphOn: html
	| jQueryId |

	jQueryId := self renderJQueryInformationDialogOn: html 
							title: 'Information' 
							information: ('Chart Saved !!' translateFor: self session user) 
							buttonLabel: ('Close' translateFor: self session user) 
							actionMethod: #saveChart.
	html div 
		class: 'display-inline-flex margin-left-5px width-100per height100per';
		with: [ 
			html div 
				class: 'margin-top-5px';
				with: [
					html anchor 
						class: 'cursor-pointer';
						onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #actionsdocumentsaveas24Png); 
										altText: ('Save Chart' translateFor: self session user); 
										title: ('Save Chart' translateFor: self session user)].
				].

			html div id: 'orbeon-graph'; class: 'overflow-scroll height100per width-100per'; with: [html html: canvas contents].
		].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/10/2016 03:14'!
renderQueryConditionOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'process-condition'; with: ('Condition Block' translateFor: self session user).

		html textArea 
			class: 'process-query-condition';
			attributeAt: 'id' put: 'process-condition'; 
			callback: [:value | self addSearchValue: value named: 'process-condition']; 
			with: (self searchValueAt: 'process-condition').
	].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:47'!
renderRolesComboOn: html 
 
	^self renderRolesComboOn: html withRoles: ((BpmFrontOfficeRole getRolsInAppName: self getApplicationName) collect: [:each | each name]) asSortedCollection! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:11'!
renderRolesComboOn: html withRoles: roleNames

	^self renderGenericActiveComboOn: html withList: (self getAllArray, roleNames) forVariable: 'role' label: ('Role' translateFor: self session user)! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/08/2016 07:17'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 01/09/2017 06:15'!
renderShowChartButtonOn: html

	html div class: 'top-search-filters-one'; 
		class: 'width-100px margin-top-20px';
		with: [
			html submitButton 
				callback: [self showChart]; 
				with: ('Show Chart' translateFor: self session user).
		].! !

!WABasicBpmChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/05/2016 11:51'!
renderStartEndDatesOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'start'; with: ('Start' translateFor: self session user).
		html textInput 
				attributeAt: 'id' put: 'start'; 
				callback: [:value | self addSearchValue: value named: 'start']; 
				with: (self searchValueAt: 'start').
	].

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'end'; with: ('End' translateFor: self session user).
		html textInput 
				attributeAt: 'id' put: 'end'; 
				callback: [:value | self addSearchValue: value named: 'end']; 
				with: (self searchValueAt: 'end').
	].! !

!WABasicBpmChartComposite methodsFor: 'Accessing' stamp: 'BrunoBB 11/18/2016 07:07'!
report
	^report! !

!WABasicBpmChartComposite methodsFor: 'Updating' stamp: 'BrunoBB 11/18/2016 07:07'!
report: newValue
	report := newValue! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:34'!
saveChart

	report addToCache! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 07:59'!
showChart

	^self subclassResponsibility! !

!WABasicBpmChartComposite methodsFor: 'other' stamp: 'BrunoBB 10/31/2016 10:29'!
svgCanvasClass

	^JASVGIGraphCanvas! !

SEWAFWebObjectComposite subclass: #WAChangeUserPasswordComposite
	instanceVariableNames: 'informationComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 05:53'!
changePassword

	informationComponent ifNil: [informationComponent := SewafInformComponent parent: self].
	(self session user password = (searchValues at: 'current-pwd')) 
	ifFalse: [^informationComponent information: ('Invalid Current Password !!!!!!' translateFor: self session user) color: 'red'].

	((searchValues at: 'repeat-new-pwd') = (searchValues at: 'new-pwd')) 
	ifFalse: [^informationComponent information:  ('New Password and Repeat New Password must be equal !!!!!!' translateFor: self session user) color: 'red'].

	self session user password: (searchValues at: 'new-pwd').

	^informationComponent information: ('Password has been changed !!!!!!' translateFor: self session user) color: 'green'! !

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'change_password.html'! !

!WAChangeUserPasswordComposite methodsFor: 'Accessing' stamp: 'BrunoBB 12/03/2016 05:53'!
informationComponent
	^informationComponent! !

!WAChangeUserPasswordComposite methodsFor: 'Updating' stamp: 'BrunoBB 12/03/2016 05:53'!
informationComponent: newValue
	informationComponent := newValue! !

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 05:53'!
renderChangePasswordOn: html

	html div id: 'change-password'; class: 'centered-unique-form';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Change Password' translateFor: self session user)].
						html label attributeAt: 'for' put: 'currentPassword'; with: ('Current Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'currentPassword'; callback: [:value | searchValues at: 'current-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword'; with: ('New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword'; callback: [:value | searchValues at: 'new-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword2'; with: ('Repeat New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword2'; callback: [:value | searchValues at: 'repeat-new-pwd' put: value].
						html submitButton callback: [self changePassword]; with: ('Confirm' translateFor: self session user).
						informationComponent ifNotNil: [html render: informationComponent].
					].
				].
		].! !

!WAChangeUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 05:53'!
renderContentOn: html

	self renderChangePasswordOn: html.! !

SEWAFWebObjectComposite subclass: #WASetUserLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBasic'!

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!WASetUserLanguage methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'fo_set_language.html'! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
renderContentOn: html

	html div id: 'internationalization'; class: 'centered-unique-form'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Select Language' translateFor: self session user).
					html select 
						attributeAt: 'id' put: 'language';
						class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self session user currentLanguage.
					html submitButton 
						callback: [self setLanguage]; 
						with: ('Set Language' translateFor: self session user).
				].
		].
	].! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
setLanguage

	self session user setLanguage: self currentDictionaryName! !
